public class Keyword implements Comparable {

    private String value;

    private Integer count;

    public Keyword() {

    }

    public Keyword(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Keyword keyword = (Keyword) o;

        if (value != null ? !value.equalsIgnoreCase(keyword.value) : keyword.value != null) return false;

        return true;
    }

    public int hashCode() {
        return (value != null ? value.toLowerCase().hashCode() : 0);
    }

    public int compareTo(Object o) {
        if (!(o instanceof Keyword))
            throw new ClassCastException("A Keyword object expected.");
        int count = ((Keyword) o).getCount();
        if (this.count > count) {
            return -1;
        } else if (this.count < count) {
            return 1;
        }
        return 0;
    }
}
